package com.fr.plugin.widget.digitroll;

import com.fr.base.FRContext;
import com.fr.log.FineLoggerFactory;

import java.math.BigDecimal;

public class Util {
    private Util() {
    }

    public static String colorValueToHexString(int color) {
        return '#' + Integer.toHexString(color).substring(2);
    }

    public static int valueChangeToInt(Object o) {
        int value = 0;
        if (o instanceof Integer) {
            value = ((Integer) o).intValue();
        } else if (o instanceof BigDecimal) {
            value = ((BigDecimal) o).intValue();
        } else if (o instanceof Double) {
            value = ((Double) o).intValue();
        } else if (o instanceof String) {
            try {
                value = Integer.parseInt(o.toString());
            } catch (Exception var4) {
                FRContext.getLogger().error(var4.getMessage(), var4);
            }
        }

        return value;
    }

    public static double valueChangeToDouble(Object o) {
        double value = 0;
        if (o instanceof Integer) {
            value = ((Integer) o).doubleValue();
        } else if (o instanceof BigDecimal) {
            value = ((BigDecimal) o).doubleValue();
        } else if (o instanceof Double) {
            value = ((Double) o).doubleValue();
        } else if (o instanceof String) {
            try {
                value = Double.parseDouble(o.toString());
            } catch (Exception e) {
                FineLoggerFactory.getLogger().error(e.getMessage());
            }
        }

        return value;
    }
}
