package com.fr.plugin.widget.digitroll.ui;

import com.fr.design.designer.creator.CRPropertyDescriptor;
import com.fr.design.designer.creator.XWidgetCreator;
import com.fr.design.gui.ilable.UILabel;
import com.fr.design.gui.itextfield.UITextField;
import com.fr.design.layout.FRGUIPaneFactory;
import com.fr.design.mainframe.widget.editors.BooleanEditor;
import com.fr.design.mainframe.widget.editors.ColorEditor;
import com.fr.form.ui.Widget;
import com.fr.general.IOUtils;
import com.fr.general.Inter;
import com.fr.stable.ArrayUtils;

import javax.swing.*;
import java.awt.*;
import java.beans.IntrospectionException;

import static com.fr.plugin.widget.digitroll.DigitRollWidget.*;

public class DigitRollWidgetUI extends XWidgetCreator {
    private UITextField textField;

    public DigitRollWidgetUI(Widget widget, Dimension dimension) {
        super(widget, dimension);
    }

    @Override
    protected JComponent initEditor() {
        if (this.editor == null) {
            this.editor = FRGUIPaneFactory.createBorderLayout_S_Pane();
            UILabel label = new UILabel();
            label.setIcon(IOUtils.readIcon("/com/fr/plugin/resources/images/digitroll_display.png"));
            label.setHorizontalAlignment(0);
            label.setVerticalAlignment(0);
            this.editor.add(label, "Center");
            this.textField = new UITextField(5);
            this.textField.setOpaque(false);
            this.editor.add(this.textField, "South");
            this.editor.setBackground(Color.WHITE);
        }

        return this.editor;
    }

    public CRPropertyDescriptor[] supportedDescriptor() throws IntrospectionException {
        String advanced = Inter.getLocText("Plugin-DigitRoll_Advanced");
        return ArrayUtils.addAll(super.supportedDescriptor(),
                (new CRPropertyDescriptor("widgetValue", this.data.getClass()))
                        .setI18NName(Inter.getLocText("Plugin-DigitRoll_DataSource"))
                        .setEditorClass(DigitRollDataSourceEditor.class)
                        .putKeyValue("category", advanced),
                (new CRPropertyDescriptor(DURATION, this.data.getClass()))
                        .setI18NName(Inter.getLocText("Plugin-DigitRoll_Duration"))
                        .putKeyValue("category", advanced),
                (new CRPropertyDescriptor(PREFIX, this.data.getClass()))
                        .setI18NName(Inter.getLocText("Plugin-DigitRoll_Prefix"))
                        .putKeyValue("category", advanced),
                (new CRPropertyDescriptor(SUFFIX, this.data.getClass()))
                        .setI18NName(Inter.getLocText("Plugin-DigitRoll_Suffix"))
                        .putKeyValue("category", advanced),
                (new CRPropertyDescriptor(FONT_SIZE, this.data.getClass()))
                        .setI18NName(Inter.getLocText("Plugin-DigitRoll_FontSize"))
                        .putKeyValue("category", advanced),
                (new CRPropertyDescriptor(FONT_COLOR, this.data.getClass()))
                        .setI18NName(Inter.getLocText("Plugin-DigitRoll_ColorFont"))
                        .setEditorClass(ColorEditor.class)
                        .putKeyValue("category", advanced),
                (new CRPropertyDescriptor(BACKGROUND_COLOR, this.data.getClass()))
                        .setI18NName(Inter.getLocText("Plugin-DigitRoll_ColorBackground"))
                        .setEditorClass(ColorEditor.class)
                        .putKeyValue("category", advanced),
                (new CRPropertyDescriptor(GROUP, this.data.getClass()))
                        .setI18NName(Inter.getLocText("Plugin-DigitRoll_Group"))
                        .setEditorClass(BooleanEditor.class)
                        .putKeyValue("category", advanced),
                (new CRPropertyDescriptor(DECIMAL_PALACES, this.data.getClass()))
                        .setI18NName(Inter.getLocText("Plugin-DigitRoll_DecimalPlaces"))
                        .setEditorClass(DecimalPlacesEditor.class)
                        .putKeyValue("category", advanced)
        );
    }

    public String getIconPath() {
        return "com/fr/plugin/resources/images/digitroll_icon.png";
    }
}
