;
(function ($) {
    FR.DigitRoll = FR.extend(FR.Widget, {
        _defaultConfig: function () {
            return $.extend(FR.DigitRoll.superclass._defaultConfig.apply(), {
                baseName: 'fr-digitRoll',
                baseClass: 'fr-digitRoll'
            });
        },

        _init: function () {
            FR.DigitRoll.superclass._init.apply(this, arguments);
            FR.$defaultImport('/com/fr/plugin/resources/web/countUp.js', 'js');
            var o = this.options;
            var element = this.element;
            var widget = element[0];

            var $widget = $('<span></span>');
            var widgetId = $widget.appendTo(element);
            $widget.css({
                'position': 'absolute',
                'left': '50%',
                'top': '50%',
                '-webkit-transform': 'translate(-50%, -50%)',
                '-moz-transform': 'translate(-50%, -50%)',
                '-ms-transform': 'translate(-50%, -50%)',
                '-o-transform': 'translate(-50%, -50%)',
                'transform': 'translate(-50%, -50%)'
            });

            this.element.css({
                'font-size': o.fontSize + 'px',
                'background-color': o.backgroundColor,
                'color': o.fontColor,
                'text-align': "center"
            });
            var options = {
                useEasing: true,        // 过渡动画效果，默认ture
                useGrouping: o.group,   // 千分位效果，例：1000->1,000。默认true
                separator: ',',         // 使用千分位时分割符号
                decimal: '.',           // 小数位分割符号
                prefix: o.prefix,       // 前置符号
                suffix: o.suffix       // 后置符号，可汉字
            };

            //debugger;
            var digitRoll = new CountUp(widgetId[0], o.value, o.value, o.decimalPlaces, o.duration, options);

            var callback = function () {
                $.ajax({
                    type: "POST",
                    url: o.widgetUrl,
                    success: function (res) {
                        var data = FR.jsonDecode(res);
                        o.data = data[0];
                        var v = data[0].value;
                        digitRoll.update(v);
                    }
                });
            };
            if (!digitRoll.error) {
                digitRoll.start(callback);
            } else {
                console.error(digitRoll.error);
            }
        }
    });

    $.shortcut("digitroll", FR.DigitRoll);
})(jQuery);
